


export class DynamicNode {
    public ident: string;
    public namespaceUri: string;
    public parentNodeId : string;
    public checkInterval :number;
    public nodeClass : string;
    public typeNodeId : string;
    public name : string;
    public startIndex:number;
    public mandatory:  string[]=[];
    public optionals?: string[]=[];
    public o_check?: boolean[]=[];
    public nodeVersionId?: string;


    constructor(options: DynamicNodeOptions) {
        this.ident = options.ident;
        this.namespaceUri =  options.namespaceUri;
        this.parentNodeId = options.parentNodeId;
        this.checkInterval = options.checkInterval;
        this.nodeClass =  options.nodeClass;
        this.typeNodeId = options.typeNodeId;
        this.name =  options.name;
        this.startIndex = options.startIndex;  
    }

    toPlainObject(){
        return { 
            ident: this.ident,
            namespaceUri: this.namespaceUri,
            parentNodeId : this.parentNodeId,
            checkInterval : this.checkInterval,
            nodeClass : this.nodeClass,
            typeNodeId : this.typeNodeId,
            name : this.name,
            startIndex: this.startIndex,
            mandatory: this.mandatory,
            optionals: this.optionals,
            nodeVersionId: this.nodeVersionId
        }
    }
}

export class ComponentPair{
    public name: string; 
    public flag: boolean;

    constructor(name = "MyName", flag = false){
        this.name = name;
        this.flag = flag;
    }
}

export interface DynamicNodeOptions {
    ident:string;
    namespaceUri:string;
    parentNodeId:string;
    checkInterval:number;
    nodeClass:string;
    typeNodeId:string;
    name:string;
    startIndex:number;
}